#pragma once
#include "Vector2.h"
#include "Vector3.h"
#include "Matrix.h"
#include <functional>
#include "Colors.h"
#include "EdgeWalker.h"
#include "Graphics.h"

struct Shader {

	Shader() {

	}

	virtual Vec3f vert(Vec3f& pos) {
		return pos;
	}

	virtual Color frag(int index, Vec3f pos, EdgeWalker walker, Vec3f normal, Graphics& gfx) {
		return Color(0, 255, 255);
	};
};

struct LitShader : public Shader{
	Color c;
	Vec3f lightDir = Vec3f(0.5,0.5,-1).normalise();

	LitShader(Color c):c(c) {

	}

	Vec3f vert (Vec3f& pos) override {
		pos.x /= pos.z;
		pos.y /= pos.z;
		Matrix::toScreenSpace(Vec2i(800,800)).mult(pos);
		return pos;
	}

	Color frag(int index, Vec3f pos, EdgeWalker walker, Vec3f normal, Graphics& gfx) override {
		Color temp = c;
		temp.mult(normal.dot(lightDir));
		//return Color(0, walker.get(EdgeWalkerCode::uvx) * 255, walker.get(EdgeWalkerCode::uvy) * 255);
		return temp;
	}
};