#pragma once
#include "MainWindow.h"
#include "Vector2.h"

template <typename T>
T clamp(const T& n, const T& lower, const T& upper) {
	return std::max(lower, std::min(n, upper));
}

Vector2<float> getInput(MainWindow& wnd) {
	Vector2<float> dir(0, 0);
	if (wnd.kbd.KeyIsPressed(VK_UP) || wnd.kbd.KeyIsPressed('W')) dir.y++;
	if (wnd.kbd.KeyIsPressed(VK_DOWN) || wnd.kbd.KeyIsPressed('S')) dir.y--;
	if (wnd.kbd.KeyIsPressed(VK_LEFT) || wnd.kbd.KeyIsPressed('A')) dir.x--;
	if (wnd.kbd.KeyIsPressed(VK_RIGHT) || wnd.kbd.KeyIsPressed('D')) dir.x++;
	return dir;
}

int mod(int number, int modulus) {
	return ((number % modulus) + modulus) % modulus;
}

int wrap(int val, int min, int max) {
	int diff = max - min;
	return min + (mod((val - min), diff));

}

int random(int min, int max) {
	return rand() % (max - min + 1) + min;
}
